# Подключение внешних проектов
include(ExternalProject)

set(MYX_REDIS_PREFIX
    ${CMAKE_BINARY_DIR}
    CACHE FILEPATH "" FORCE)
set(MYX_REDIS_INCLUDE_DIR
    ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_INCLUDEDIR}
    CACHE PATH "" FORCE)
set(MYX_REDIS_INCLUDE_DIRS
    ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_INCLUDEDIR}
    CACHE PATH "" FORCE)
set(MYX_REDIS_LIBRARY_DIR
    ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR}
    CACHE PATH "" FORCE)
set(MYX_REDIS_LIBRARIES
    ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR}/libmyx-redis.a
    CACHE FILEPATH "" FORCE)

# cmake-format: off
list(APPEND _ext_project_args
  myx-redis
  SOURCE_DIR       ${CMAKE_SOURCE_DIR}/thirdparty/myx-redis
  INSTALL_DIR      ${CMAKE_BINARY_DIR}
  CMAKE_ARGS       ${MYX_CMAKE_EXTERNAL_PROJECT_ARGS}
                   <SOURCE_DIR>)
if(MyxRedisThirdparty_FIND_COMPONENTS STREQUAL "headers")
  list(APPEND _ext_project_args
    BUILD_COMMAND    true
    INSTALL_COMMAND  ${CMAKE_MAKE_PROGRAM} myx-redis-install-headers)
else()
  list(APPEND _ext_project_args
    BUILD_BYPRODUCTS ${MYX_REDIS_LIBRARIES})
endif()
ExternalProject_Add(${_ext_project_args})
unset(_ext_project_args)

set(MYX_REDIS_IS_EXTERNAL_PROJECT ON CACHE BOOL "" FORCE)
# cmake-format: on
